#include <iostream>

template<int N>
struct classify
{
	static const bool good = false;
};

template<>
struct classify<42>
{
	static const bool good = true;
};



void main1()
{
	std::cout << classify<13>::good << std::endl;
	std::cout << classify<42>::good << std::endl;
}


/*

template<int N, classify<N>::good == false>
void do_something()
{
	// be evil
}

template<int N, classify<N>::good == true>
void do_something()
{
	// be good
}

*/

























/* struct containing a given type iff the second template is true */
template<typename T, bool b> struct test;

template<typename T>
struct test<T, false>
{
	// nothing
	static int type;
};
template<typename T>
struct test<T, true>
{
	typedef T type;
};




/* function using this to distinguish good and bad */
template<int N>
typename test<void, classify<N>::good == true>::type do_something()
{
	std::cout << "It's all right" << std::endl;
}

template<int N>
typename test<void, classify<N>::good == false>::type do_something()
{
	std::cout << "You have been nasty. This has to be punished." << std::endl;
	*static_cast<int*>(nullptr) = 0; // crash NOW!
}



void main2()
{
	do_something<11>();
	std::vector<bool> a;
}



int main()
{
	main1();
	main2();
	return 0;
}
