#include <iostream>
#include <string>

/* Berechne das kleinste Element eines Arrays. Es muss size >= 1 gelten! */
template<typename T>
T arraymin(T *array, unsigned int size)
{
	T min = array[0];
	for (unsigned int i = 1; i < size; ++i) {
		if (array[i] < min)
			min = array[i];
	}
	return min;
}












int main()
{
	int intdata[]{ 22, 12, 9, 7, 55, 178, 6 };
	unsigned intdata_size = sizeof(intdata)/sizeof(*intdata);
	std::string stringdata[]{ "hallo", "welt", "peter", "bodensee", "zugspitze" };
	unsigned stringdata_size = sizeof(stringdata)/sizeof(*stringdata);
	std::cout << arraymin(intdata, intdata_size) << std::endl;
	std::cout << arraymin(stringdata, stringdata_size) << std::endl;
	return 0;
}
